/*
 * CDDL HEADER START
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License (the "License").
 * You may not use this file except in compliance with the License.
 *
 * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
 * or http://www.opensolaris.org/os/licensing.
 * See the License for the specific language governing permissions
 * and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 * CDDL HEADER END
 */

/*
 * Copyright (c) 1990, 2010, Oracle and/or its affiliates. All rights reserved.
 * Copyright 2012 Nexenta Systems, Inc.  All rights reserved.
 */

#ifndef	__UTIL_H
#define	__UTIL_H

#ifdef	__cplusplus
extern "C" {
#endif

#define	EOS '\0'

#define	MALLOC(object_type) ((object_type *)malloc(sizeof (object_type)))

#define	FREE(ptr)	free((char *)ptr)

#define	STRCPY(dst, src) \
	(dst = malloc((unsigned)strlen(src)+1), (void)strcpy(dst, src))

#define	STRNCPY(dst, src, num) \
	(dst = (char *)malloc((unsigned)(num) + 1),\
	(void) strncpy(dst, src, num), (dst)[num] = EOS)

char *getaline();

#ifdef	__cplusplus
}
#endif

#endif	/* __UTIL_H */
